/*-----------------------------------------------------------------------------
	Paper Plane xUI	 setup wizard
-----------------------------------------------------------------------------*/
#include "WINAPI.H"
#include <windowsx.h>
#include <commctrl.h>
#include <shlobj.h>
#include "PPX.H"
#include "VFS.H"
#include "PPSETUP.RH"

#ifndef BIF_USENEWUI
#define BIF_USENEWUI 0x50
#endif

#define LOWSETTINGMEM_MB 384	// XybNpݒɂ郁
								// (MB,wlȉ͒XybNݒɂȂ)

#ifdef UNICODE
	#define XNAME	"PPW"
	#ifdef _WIN64
		#define COMMONDLL "PPLIB64W.DLL"
		#define ARCNAME "./ppx64"
	#else
		#define COMMONDLL "PPLIB32W.DLL"
		#define OLDCOMMONDLL "PPXLIB32.DLL"
		#define ARCNAME "./ppw"
	#endif
	#define CEXE	"PPCW.EXE"
	#define CSEXE	"PPCUSTW.EXE"
	#define CustID	"TC2"
	#define HistoryID "TH2"
#else
	#define XNAME	"PPX"
	#define COMMONDLL "PPLIB32.DLL"
	#define OLDCOMMONDLL "PPCOMMON.DLL"
	#define ARCNAME "./ppx"
	#define CEXE	"PPC.EXE"
	#define CSEXE	"PPCUST.EXE"
	#define CustID	"TC1"
	#define HistoryID "TH1"
#endif

#define PROPTYPE	1		// 0:prop 1:wizard
#define PROPPAGE	12		// Sy[W
#define PROPTITLE	T("PPx Setup Wizard (") T(BITSTRING) T(",") T(CODETYPESTRING) T(")")
#define MENUDIRNAME		"PaperPlane xUI"

#if PROPTYPE
	#define PROPSTYLE	PSH_WIZARD
#else
	#define PROPSTYLE	PSH_PROPSHEETPAGE
#endif

//------------------------------------------------------------------ V[gǗ
typedef struct {	// ey[W̏ۑ邽߂̍\
										// 炩ߏKv
	int		rID;	// \[XID
	DLGPROC proc;	// R[obN֐ANULL ȂgȂ
} PAGEINFO;

typedef struct {
	const TCHAR *filename;
	const TCHAR *dispname;
} INSTALLFILES;

enum {	PAGE_GUIDE = 0, PAGE_SETTYPE, PAGE_UN_EXEC, PAGE_DEST, PAGE_REG,
		PAGE_PPCW, PAGE_KEY, PAGE_APP, PAGE_LINK, PAGE_READY, PAGE_COPY,
		PAGE_UP};

enum {	RESULT_NORMAL = 0, RESULT_FAULT, RESULT_SUCCESS, RESULT_ALLDONE,
		RESULTINFO_UNINSTALLDATA, RESULTINFO_INSTALL,
		MSG_UNICODE, MSG_SELECTPPX, MSG_SELECTUPDATE, MSG_OVERINSTALL,
		MSG_SELECTDIR, MSG_DEFAULTDIR, MSG_NOCOPY, MSG_SELECTEDITOR,
		MSG_SELECTVIEWER, MSG_SELECTSUSIE, MSG_ABORT, MSG_FAILACCESS,
		MSG_FAILCOPY, MSG_DLLLOADERROR, MSG_SITEERROR, MSG_RELOADARCHIVE,
		MSG_BACKUP, MSG_FOUND, MSG_RUNAS, MSG_UNZIP, MSG_BADSIG,
		MSG_COPYNOFILE,
		MSG_DLL_LOADERROR_PART,
};

//-----------------------------------
extern OSVERSIONINFO OSver;	// OS 
extern int XX_setupmode;				// ZbgAbv@
extern TCHAR XX_setupedPPx[VFPS];		// ZbgAbvς݂ PPx path
extern PAGEINFO *UsePageInfo;
extern const TCHAR **MessageStr;
//----------------------------------- CXg[
extern int XX_instdestM;				// CXg[̎
extern TCHAR XX_instdestP[VFPS];		// Programs File ̃CXg[
extern TCHAR XX_instdestS[VFPS];		// w̃CXg[
extern TCHAR *XX_setupPPx;				// CXg[/Abvf[g

extern TCHAR XX_upsrc[VFPS];			// Abvf[g
extern int XX_usereg;					// WXg𗘗p邩
extern int XX_ppc_window;				// ppc ̑̌`
extern BOOL XX_ppc_tree;				// ppc ̑Ƀc[\
extern int XX_ppc_pane;				// ppc ̑̃yC
extern int XX_ppc_tab;					// ppc ̑̃^u`
extern int XX_ppc_join;				// ppc ̘̑A`
extern int XX_keytype;					// L[蓖ĕ@
extern BOOL XX_diakey;					// _CAhJ[\
extern BOOL XX_emenu;					// pꃁj[
extern BOOL XX_doscolor;				// DOSzF
extern TCHAR XX_editor[VFPS];			// eLXgGfB^
extern TCHAR XX_viewer[VFPS];			// ėpr[A
extern TCHAR XX_susie[VFPS];			// Susie plug-in
extern BOOL XX_usesusie;				// Susie plug-in ̐ݒgp
extern BOOL XX_resultquiet;				// G[ȂΌʉʂȗ
extern int XX_link_menu;				// X^[gj[ɓo^
extern int XX_link_cmenu;				// pX^[gj[ɓo^
extern int XX_link_boot;				// X^[gAbvɓo^
extern int XX_link_desk;				// fXNgbvɓo^
extern int XX_link_app;				// ǉƍ폜ɓo^

extern const TCHAR *UNARCS[];

//------------------------------------------------------------------

// PPLIBxxx.DLL ̒`
typedef int (PPXAPI * PASSETCUSTTABLEA)(const char *str, const char *sub, void *bin, DWORD b_size);
typedef int (PPXAPI * PASSETCUSTTABLEW)(const WCHAR *str, const WCHAR *sub, void *bin, DWORD b_size);
typedef HRESULT (PPXAPI * MAKESHORTCUTA)(const char *LinkedFile, const char *LinkFname, const char *DestPath);
typedef HRESULT (PPXAPI * MAKESHORTCUTW)(const WCHAR *LinkedFile, const WCHAR *LinkFname, const WCHAR *DestPath);
typedef void (PPXAPI * PASXSEND)(UINT uMsg, WPARAM wParam, LPARAM lParam);
typedef void (USECDECL * OLDXSEND)(UINT uMsg, WPARAM wParam, LPARAM lParam);

// WINAPI
ExternWinAPI(HRESULT, SHGetFolderPath, (HWND hwnd, int csidl, HANDLE hToken, DWORD dwFlags, LPTSTR pszPath));

// _CAO
INT_PTR CALLBACK StyleDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

INT_PTR CALLBACK GuideDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK SetTypeDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK UnExecDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK DestDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK RegDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK PPcwDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK KeyDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK AppDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK LinkDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK UpDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK CopyDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK ReadyDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

#define AUTOSETUP_FIN	0
#define AUTOSETUP_COPYDIALOG	1
extern int AutoSetup(const TCHAR *param);
//------------------------------------------------------------------ PPSETUP.C
extern HINSTANCE hInst;
extern HWND hResultWnd; // ʂރ{bNX

#define SRESULT_NOERROR 0
#define SRESULT_FAULT 1
#define SRESULT_ACCESSERROR 2
extern int SetupResult;		// L
extern BOOL DeleteUpsrc;	// I XX_upsrc 폜
extern TCHAR MyPath[VFPS];	// g̃fBNg

extern INSTALLFILES InstallFiles[];
extern const TCHAR NilStr[];
extern const TCHAR Str_PPxRegPath[];
extern const TCHAR Str_InstallPPxPath[];
extern const TCHAR Set_InstallPPxName[];
extern const TCHAR msgboxtitle[];

//------------------------------------------------------------------ PPSET_S.C
extern void Cmd(TCHAR *param);
extern void CheckDlgButtons(HWND hDlg, int start, int end, int check);
extern void CloseAllPPxLocal(TCHAR *destpath, BOOL setuppath);
extern BOOL CopyPPxFiles(HWND hWnd, const TCHAR *srcpath, const TCHAR *destpath);
extern int GetDlgButtons(HWND hDlg, int start, int end);
extern BOOL GetRegStrLocal(HKEY hKey, const TCHAR *path, const TCHAR *name, _Out_ TCHAR *dest);
extern BOOL SearchPPxPath(void);
extern BOOL SelectDirectory(HWND hWnd, const TCHAR *title, UINT flag, BFFCALLBACK proc, TCHAR *path);
extern int CALLBACK SelDirProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
extern int CALLBACK SelInstPPxProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
extern void SetExecuteFile(HWND hWnd, int ID, const TCHAR *title);
extern void USEFASTCALL SMessage(const TCHAR *str);
extern void WriteResult(const TCHAR *str, int add);
extern ERRORCODE Execute_ExtractMacro(const TCHAR *param, BOOL error_dialog);

extern BOOL DeleteDir(const TCHAR *path);
extern BOOL GetWinAppDir(int csidl, TCHAR *path);

#define ADMINMODE_NOADMIN	0
#define ADMINMODE_ADMIN		1
#define ADMINMODE_ELEVATE	2
extern int AdminCheck(void);

//------------------------------------------------------------------ PPSET_IN.C
extern BOOL InstallMain(HWND hWnd);

//------------------------------------------------------------------ PPSET_DG.C
